# -*- coding: utf-8 -*-
from setuphelpers import *

# case-insensitivity
non_unique_uuids = [
    "90218F6F-8B87-8442-8AAD-4A676F39B1F3",
    "FFFFFFFF-FFFF-FFFF-FFFF-FFFFFFFFFFFF",
]


def install():
    try:
        try:
            uuid_bios = dmi_info()["System_Information"]["UUID"]
        except:
            uuid_bios = dmi_info()["System_Information"][0]["UUID"]
    except:
        print('This computer probably needs "include_dmi_inventory=1" parameter.')
    print("UUID BIOS: " + uuid_bios)
    uuid_wapt = WAPT.host_uuid
    print("UUID WAPT: " + uuid_wapt)

    if any([True for u in non_unique_uuids if u.lower() == uuid_bios.lower()]):
        new_uuid_wapt = str(WAPT.generate_host_uuid())
        print("New UUID WAPT: " + new_uuid_wapt)
        try:
            WAPT.register_computer()
        except:
            pass
        if get_os_name() == "Windows":
            wapt_get_path = makepath(WAPT.wapt_base_dir, "wapt-get.exe")
            create_onetime_task("restart-waptservice", wapt_get_path, "restart-waptservice", 2)
            print("waptservice will restart in 2mins.")
        else:
            print("waptservice may need to be restarted.")
    elif uuid_wapt.lower().startswith("rnd-") and not any([True for u in non_unique_uuids if u.lower() == uuid_bios.lower()]):
        print(
            'This machine has already generated a random uuid. Based on the non_unique_uuids list provided, it does not seem to be needed. You may want to deploy the "tis-wapt-reset-uuid" package.'
        )
    else:
        print("Based on the non_unique_uuids list provided. This computer does not need to generate a random uuid.")

    # old method
    # if not inifile_hasoption(WAPT.config_filename, "global", "uuid"):
    #     for uuid in bad_uuid:
    #         if uuid == uuid_bios:
    #             WAPT.generate_host_uuid()
    #             print("New uuid in wapt-get.ini : " + inifile_readstring(WAPT.config_filename, "global", "uuid"))
    #             try:
    #                 WAPT.register_computer()
    #             except:
    #                 pass
